#include<cstdlib>
#include<iostream>
#include<fstream> 
#include<vector> 
#include<cmath> 

using namespace std; 

int main() {
   
    vector<int> v; 

    ifstream read_value; 
    read_value.open("ligand_conc.txt"); 

    double value; 
    while(!read_value.eof()) {
        read_value >> value; 
        v.push_back((int) (600.0*(pow(10,value)))); 
    } 

    read_value.close(); 

    vector<pair<int,double> > ligand_bound;  
    vector<pair<int,double> > receptor_in_gel;   

    ligand_bound.clear(); 
    receptor_in_gel.clear(); 
    
    for (vector<int>::const_iterator it = v.begin(); it != v.begin()+41; it++) {
     
        ofstream write_param;   
        write_param.open("param.txt"); 

        write_param << "#define n_lig " <<  (*it)  << endl; 

        write_param.close(); 

        system("mv param.txt src/core/"); 
        system("cat src/core/first.txt src/core/param.txt src/core/second.txt > src/core/core.h"); 

        system("make clean"); 
        system("make"); 
        system("./bin/cell"); 

        pair<int,double> p;     
        double output_value;  
        ifstream read_ligand_bound;  
        read_ligand_bound.open("amount_ligand_bound.txt"); 
        read_ligand_bound >>  output_value; 
        read_ligand_bound.close(); 
        p.first = (*it); 
        p.second = output_value; 
        ligand_bound.push_back(p); 
        
        pair<int,double> p1;     
        double output_value1;  
        ifstream read_receptor_in_gel;   
        read_receptor_in_gel.open("amount_receptor_in_gel.txt"); 
        read_receptor_in_gel >>  output_value1; 
        read_receptor_in_gel.close(); 
        p1.first = (*it); 
        p1.second = output_value1; 
        receptor_in_gel.push_back(p1); 
    } 

    ofstream write_bound_ligand; 
    write_bound_ligand.open("result_amount_bound_ligand.txt"); 
    for (vector<pair<int,double> >::const_iterator it = ligand_bound.begin(); it != ligand_bound.end(); it++) {
        write_bound_ligand << (double) (((*it).first)/600.0) << "     " << (*it).second << endl; 
    } 

    write_bound_ligand.close(); 
    
    ofstream write_receptor_in_gel; 
    write_receptor_in_gel.open("result_amount_receptor_in_gel.txt"); 
    for (vector<pair<int,double> >::const_iterator it = receptor_in_gel.begin(); it != receptor_in_gel.end(); it++) {
        write_receptor_in_gel << (double) (((*it).first)/600.0) << "     " << (*it).second << endl; 
    } 
  
    write_receptor_in_gel.close(); 


    return 0; 

} 
