#include "core/core.h" 
#include"tlbr.h"

int main() {

Cell* cell = new Cell(); 
cell->create_solution_compartment(); 
cell->create_membrane_compartment(); 
cell->define_reactions(); 
cell->create_receptor_molecule(n_rec); 
cell->create_ligand_molecule(n_lig); 


cell->propagate_reaction(); 

vector<Molecule*> mlist = cell->molecule_list["R"]; 

//cell->save_species(); 


vector<pair<double,vector< vector<Molecule*> > > > species = cell->receptor_aggregate; 

vector<pair<double,vector< vector<Molecule*> > > >::const_iterator it; 

for (it = species.begin(); it != species.end(); it++) {
    pair<double, vector< vector<Molecule*> > > p = (*it); 
    cout << "Time: " << p.first << endl; 
    vector< vector<Molecule*> > complex_list = p.second; 
    vector< vector<Molecule*> >::const_iterator jt; 
    for (jt = complex_list.begin(); jt != complex_list.end(); jt++) {
        vector<Molecule*> complx = (*jt); 
        vector<Molecule*>::const_iterator kt; 
        for (kt = complx.begin(); kt != complx.end(); kt++) {
                Molecule* mol = (*kt); 
                cout << "-" << mol->name << "(" << mol->id << ")" << "-"; 
        }

        cout << endl << endl; 
    }
} 

cell->print_mean_amount_ligand_bound(); 
cell->print_ligand_bound();
cell->print_sol_gel_composition(); 
cell->print_mean_aggregate_size();

return 0; 

} 

